//=======================================================================================================
// Exercise     : AD8H13P4.Longest_Path
// Template URL : https://www.cadmo.ethz.ch/education/lectures/HS18/DA/uebungen/AD8H13P4.Longest_Path.zip
// Author       :  
//=======================================================================================================

import java.io.InputStream;
import java.io.PrintStream;
import java.util.Scanner;

import java.util.Stack;
import java.util.List;
import java.util.ListIterator;
import java.util.ArrayList;


class Main {	
	
	public static void read_and_solve(InputStream in, PrintStream out) {

		Scanner scanner = new Scanner(in);
		//
		// Read the number of paragraphs and page width
		//
		int case_no, cases = scanner.nextInt();
		for (case_no = 1; case_no <= cases; case_no++) {
			//
			// Read the number of vertices and edges
			//
			int n = scanner.nextInt();
			int m = scanner.nextInt();
			int i;
			//
			// There are several representations of the graph, choose what seems
			// useful:
			//
			// For every edge, the source and target vertex
			//
			int[] edge_from = new int[m];
			int[] edge_to   = new int[m];
			//
			// For every vertex V, List of vertices X with direct edge from V to X
			// 
			List<List<Integer>> v_out = new ArrayList<List<Integer>>();
			//
			// For every vertex V, List of vertices X with direct edge to V from X
			// 
			List<List<Integer>> v_in  = new ArrayList<List<Integer>>();

			// Create the empty lists
			for (i = 0; i < n; i++) {
				v_out.add (new ArrayList<Integer>());
				v_in.add  (new ArrayList<Integer>());
			}
			//	
			// Read elements of A and elements of B
			//
			for (i = 0; i < m; i++) {
				// Read the edge
				int s = scanner.nextInt();
				int t = scanner.nextInt();
				// Insert into all three graph representations
				edge_from[i] = s;
				edge_to[i] = t;
				v_out.get(s).add(t);
				v_in.get(t).add(s);
			}

			// First, compute the topological order
			
			// The List to hold the topological order, empty
			ArrayList<Integer> order = new ArrayList<Integer>();

			// TODO: Put your implementation here

			// TODO: Output the length of the longest path
			// out.println(42);			
		}

		scanner.close();
	}

	//
	// Do not modify the main method, and keep the method read_and_solve
	// 
	public static void main(String[] args) {	
		read_and_solve(System.in, System.out);		
	}
}